#!/usr/bin/env python
# -*- coding: utf-8 -*-

from time import sleep
from time import strftime
from datetime import datetime
import snap7
from snap7.util import*
import struct
import string
from time import*
import serial, time
from RPi import GPIO
import os
import sys

############################ Doorpi Datenpfad ###############################

# Datenpfat virtual Keyboard
Dateipfad_imput1 = '/var/DoorPI/keyboard/inputs/e1'
Dateipfad_output1 = '/var/DoorPI/keyboard/outputs/a1'


############################## Parameter SPS ################################
ip='192.168.178.30'    # IP Adrresse SPS
rack = 0
slot = 2
S7_DRead = [69,2,8]    #Adresse Bit lesen aus SPS
S7_DWrite = [69,0]     #Adresse Bit schreiben in SPS
plc = snap7.client.Client()




############################# Nextion Display ################################

EndCom = "\xff\xff\xff"
ser = serial.Serial('/dev/ttyUSB0', 9600, timeout=1)
LCD_Display_Zeile = ["*","*","*","*","*"]


################################ GIPO Pins ###################################   

GPIO.setmode(GPIO.BOARD)

# Pin 16 (GPIO 23) Bewegungsmelder als Eingang festlegen
PIR_PIN = 16
GPIO.setup(PIR_PIN, GPIO.IN, pull_up_down = GPIO.PUD_DOWN)


################################ Logfile #################################### 
#Logfile Ordner
logfile = '/home/pi/S7/Log/logfile_'+time.strftime("%d.%m.%Y")+'.log'


############################## Funktionen ################################### 


def Write_V_Keyboard (value):
    try:
        #print "Schreibe in Virtual_Keyboard"
        f = open (Dateipfad_imput1 ,"w")
        v =str(value)
        f.write(v)
        f.close()
        
    except Exception as ex:
        print ("Fehlerm beim schreiben in Virtual Keyboard",ex)
        log("Fehlerm beim schreiben in Virtual Keyboard")
        sleep(0.1)
        


def Read_V_Keyboard(): 
    try:
        #print "Value aus Doorpi Virtual Keyboard lesen"
        f = open (Dateipfad_output1,"r")
        v = f.readline()
        f.close()
        BOOL = State_BOOL(v)
        return BOOL
    except Exception as ex:
        print ("Fehlerm beim lesen aus Virtual Keyboard",ex)
        log("Fehlerm beim lesen aus Virtual Keyboard")
        sleep(0.1)
        
        

def Nextion_Write_Text(serial_obj, input_str, Nr):
    try:
        
        Nex_str = 't'+str(Nr)+'.txt='+'"'+input_str+'"'
        serial_write = Nex_str + EndCom
        serial_obj.write(serial_write)
     
    except Exception as ex:
        print ("Fehler Display",ex)
        log("Fehler Display")
        sleep(0.1)

def Nextion_Write(serial_obj, input_str):
    try:
        serial_write = input_str + EndCom
        serial_obj.write(serial_write)
     
    except Exception as ex:
        print ("Fehler Display",ex)
        log("Fehler Display")
        sleep(0.1)


def Nextion_Dim(dim):
    Nextion_Write(ser, 'dim='+str(dim))
        
        


def State_BOOL(Value):
    if 'True'  in Value:
        BOOL = True
    else:
        BOOL = False
    return BOOL


def log(msg):
    #Log
  file = open(logfile,"a")
  file.write("%s: %s\n" % (time.strftime("%d.%m.%Y %H:%M:%S"), msg))
  file.close


  
##################### Hauptprogramm ##############################



def main():
                
        
    Verbindung = False
    con = False
    Bewegungsmelder = False
    Nextion_Licht = False
    Nextion_BildNr = 0
    Nextion_BildNrSP= 0
    FmBewegungsmelder = False
    DELTA = 30
    sleep(2.0)
    start = datetime.now()
    log("Run")
    log(start)

    
    Flag = False
    Flag_2 = False
    P_Flak_KlingT_1 = False
    N_Flak_KlingT_1 = False
    P_Flak_Bewegm = False
    N_Flak_Bewegm = False


    
    try:
    
        while True:
            try:
                
  
                if con == False: 
                    #print "Verbindungsaufbau"
                    plc.connect(ip,rack,slot)
                    con = plc.get_connected()
                    if con == True:
                        print "Connect SPS "+str(ip)
                        sleep(3.0)
                    else:
                        print "keine Verbindung zur SPS"
                        sleep(3.0)
                
                
                #print"lese Daten aus SPS"
                data = plc.db_read(S7_DRead[0],S7_DRead[1],S7_DRead[2])
                
                #schreibe Daten von SPS in Variablen
                Klingeltaster_1     = get_bool(data,0,0)
                #print "Klingeltaster_1  ",Klingeltaster_1
                #Klingeltaster_2     = get_bool(data,0,1)
                #print "Klingeltaster_2  ",Klingeltaster_2
                Nextion_BildNr = get_int(data,2)
               
                # Flankenmerker Klingeltaster                
                P_Flak_KlingT_1 = Klingeltaster_1 and not Flag
                N_Flak_KlingT_1 = not Klingeltaster_1 and Flag
                Flag = Klingeltaster_1
                
                #schreibe Daten (Klingeltaster_1) in Virtual Keyboard Flankenmerker
                if P_Flak_KlingT_1:
                    Write_V_Keyboard(True)
                    print "Es wird geklingelt"
                    
                elif N_Flak_KlingT_1:
                    Write_V_Keyboard(False)
                    print "Taster Losgelassen"
                
                                   
                #print"lese Daten aus Virtual Keyboard"
                Tuer_Oeffner = Read_V_Keyboard()
                if Tuer_Oeffner == True:
                    print "Tür Öffner       ",Tuer_Oeffner
                            
                #Schreibe Bildnummer in Nextion Display nur wenn speicher letztes bild ungleich
                if Nextion_BildNr <> Nextion_BildNrSP:
                    Nextion_Write(ser, 'page '+str(Nextion_BildNr))
                    Nextion_BildNrSP = Nextion_BildNr
                    print "Nextion Bildwechsel auf",Nextion_BildNr
                                                
                                
                #Bewegungsmelder auslesen
                Bewegungsmelder = GPIO.input(PIR_PIN)
                #print ('Bewegungsmelder   False' if Bewegungsmelder < 1 else 'Bewegungsmelder   True')
                
                #Nextion Display Hell schalten
                if Bewegungsmelder == 1:
                    action_time = datetime.now()

                P_Flak_Bewegm = Bewegungsmelder and not Flag_2
                N_Flak_Bewegm = not Bewegungsmelder and Flag_2
                Flag_2 = Bewegungsmelder
                                    
                if P_Flak_Bewegm:
                    print "Bewegung erkannt Nextion Licht AN"
                    Nextion_Licht = True
                    Nextion_Dim(100)
                                   
                #Ausschaltverzögerung Nextion Display Belechtung
                if Nextion_Licht and (datetime.now() - action_time).seconds > DELTA:
                    print "Nextion Licht AUS"
                    Nextion_Licht = False
                    #print "Start_Time" , datetime.now()
                    #Nextion Display Dimmen nach ablauf der Verzögerungszeit DELTA
                    Nextion_Dim(1)
                   
                                   
                #Verbindungssstatus Toggen
                if Verbindung == True:
                    Verbindung = False
                else:
                    Verbindung = True
                
                #print"schreibe Daten in Sendedatei"
                data_send = bytearray(2)
                set_bool(data_send,0,0,Verbindung,)
                set_bool(data_send,0,1,Tuer_Oeffner,)
                set_bool(data_send,0,2,Bewegungsmelder,)
                #set_bool(data_send,0,3,Stoerung,)
                #print "Störung", Stoerung
                    
                #print"Schreibe Daten in SPS"
                plc.db_write(S7_DWrite[0],S7_DWrite[1],data_send)
                     
                #Wartezeit
                sleep(0.2)
                

            except Exception as ex:
                print ("Verbindungsfehler",ex)
                con = False
                plc.disconnect()
                plc.destroy()
                log(ex)
                sleep(10.0)

    except KeyboardInterrupt:
        print "GIPO cleanup"
        GPIO.cleanup()
        print "PLC disconnect"
        plc.disconnect()
        plc.destroy()
        print "Beende...."
        sys.exit(0)
           

if __name__ == "__main__":
    main()
    